#include <stdio.h>

void zamjena(int* a, int* b)
{
    int temp;

    temp=*a;
    *a=*b;
    *b=temp;
}


int abs(int a)
{
    return a>0?a:-a;
}


void fa(int Ax[], int Ay[], int Bx[], int By[], int n)
{
    int i, j;

    for(i=0; i<n-1; i++)
        for(j=i+1; j<n; j++){
            if(Ay[i]-By[i]){                       /*Slucaj kad i-ti pravac NIJE paralelan s x-osi.*/
                if(abs(Ay[i]-By[i])>abs(Ay[j]-By[j])){  /*Ako je j-ti pravac paralelan s x-osi, onda ce sigurno*/
                    zamjena(&Ax[i],&Ax[j]);             /*biti zamjena jer ce ovaj uvjet biti ispunjen.*/
                    zamjena(&Ay[i],&Ay[j]);
                    zamjena(&Bx[i],&Bx[j]);
                    zamjena(&By[i],&By[j]);
                }
            }
            else{
                if(abs(Ax[i]-Bx[i])>abs(Ax[j]-Bx[j]) && !(Ay[j]-By[j])){ /*Buduci da je i-ti pravac paralelan s x-osi, zamjena je moguca*/
                    zamjena(&Ax[i],&Ax[j]);                              /*tek kad je i j-ti pravac paralelan s x-osi.*/
                    zamjena(&Ay[i],&Ay[j]);
                    zamjena(&Bx[i],&Bx[j]);
                    zamjena(&By[i],&By[j]);
                }
            }
        }
}


int fb(int Ax[], int Ay[], int Bx[], int By[], int n, int d)
{
    int lijevi=0, desni=n-1, srednji, indeks=-1;

    while(lijevi<=desni){
        srednji=(lijevi+desni)/2;
        if(!(Ay[srednji]-By[srednji])){
                if(abs(Ax[srednji]-Bx[srednji])==d){
                    indeks=srednji;
                    break;
                }
                if(abs(Ax[srednji]-Bx[srednji])>d)
                    desni=srednji-1;
                else
                    lijevi=srednji+1;
        }
        else
            desni=srednji-1; /*Slucaj kad je srednji pao medju pravce paralelne s y-osi*/
    }

    return indeks;
}


int main(void)
{
    int Ax[]={-100,2,5}, Bx[]={1,0,7}, Ay[]={5,6,3}, By[]={5,6,3};
    int n=3, i, d=2;

    for(i=0; i<n; i++)
        printf("[(%d,%d),(%d,%d)]\n", Ax[i], Ay[i], Bx[i], By[i]);
    printf("\n");

    fa(Ax,Ay,Bx,By,n);
    for(i=0; i<n; i++)
        printf("[(%d,%d),(%d,%d)]\n", Ax[i], Ay[i], Bx[i], By[i]);

    printf("\nDuzina duljine %d je na mjestu %d\n", d, fb(Ax,Ay,Bx,By,n,d));

    return 0;
}
