#include <stdio.h>

double horner(int n, double t[], double x)
{
    int i;
    unsigned f=1;
    double p=0, b;

    b=x-2;
    for(i=n; i>=0; i--){
        p=p*b+t[i]*f;
        f*=n-i+1;  /*s ovim racunamo faktorijele linearnom slozenoscu*/
    }

    return p;
}

int main(void)
{
    double t[]={1,2,3,4}, x=3;
    int n=3;

    printf("p(%g)=%g\n", x, horner(n,t,x));

    return 0;
}
